{------[ TctCxGridIme ]---------------------------------------------------
* ݩ

- property Grid: TcxGrid
  (n)

- property GridView: TcxCustomGridTableView
  GridTableView, GridTableBandedView, GridCardView i
  (n)

- property EffectFieldNames: String
  nJkW١AH';'','ϹjC

- property ImeName: String
  Jk

* Ϊk

- ҡG

1  ImeHelp := TctCxGridIme.Create(self);          //1.  إߤ
2  ImeHelp.Grid := cxGrid1;                       //2~5.]wݩ
3  ImeHelp.GridView := cxGrid1DBTableView1;
4  ImeHelp.ImeName := ' (c) - `';
5  ImeHelp.EffectFieldNames := 'CustNo; Addr1';

- HWdҡA찱b CustNo P Addr1 ɡAN|Jk
  l쳣|_^ơC

* @

- i@.Taipei

- vincent@family-chang.idv.tw

- ̫קG2004-05-31 PM 04:00
-------------------------------------------------------------------------------}

unit ctCxGridIme;

interface

uses
//--- Standard ----------------
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
//--- inherited from ----------
  ctCustomIme,
//--- cxGrid and cxGridView ---
  cxGrid, cxGridCustomTableView, cxGridTableView, cxGridDBTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxGridCardView,
  cxGridDBCardView;

type
  TctCxGridIme = class(TctCustomGridIme)
  private
    FGridTableView: TcxCustomGridTableView;
    FGrid: TcxGrid;
    procedure SetGridTableView(const Value: TcxCustomGridTableView);
    procedure SetGrid(const Value: TcxGrid);
  private
    FOldViewOnFocusedItemChanged: TcxGridFocusedItemChangedEvent;
    function  GetfieldImeName(ACustomView: TcxCustomGridTableView; AFieldIndex: Integer): String; overload;
    function  GetFieldImeName(AGridView: TcxGridTableView; AFieldIndex: Integer): String; overload;
    function  GetFieldImeName(AGridView: TcxGridBandedTableView; AFieldIndex: Integer): String; overload;
    function  GetFieldImeName(ACardView: TcxGridCardView; AFieldIndex: Integer): String; overload;
  protected
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;

    procedure ActiveLastIme; override;
    procedure ViewOnFocusedItemChanged(Sender: TcxCustomGridTableView;
      APrevFocusedItem, AFocusedItem: TcxCustomGridTableItem); virtual;
  published
    property Grid: TcxGrid read FGrid write SetGrid;
    property GridView: TcxCustomGridTableView read FGridTableView write SetGridTableView;
  end;

implementation

{ TctCxGridIme }

procedure TctCxGridIme.ActiveLastIme;
begin
  if Assigned(FGridTableView) then
  begin
    if LastImeName = none_ImeName then
      LastImeName := GetFieldImeName(FGridTableView, 0);
    inherited;
  end;
end;

function TctCxGridIme.GetFieldImeName(AGridView: TcxGridTableView;
  AFieldIndex: Integer): String;
var
  Column: TcxGridColumn;
begin
  Result := Screen.DefaultIme;
  Column := AGridView.Columns[AFieldIndex];
  if Column is TcxGridDBColumn then
    Result := GetFieldImeName(TcxGridDBColumn(Column).DataBinding.FieldName)
end;

function TctCxGridIme.GetFieldImeName(ACardView: TcxGridCardView;
  AFieldIndex: Integer): String;
var
  Row: TcxGridCardViewRow;
begin
  Result := Screen.DefaultIme;
  Row := ACardView.Rows[AFieldIndex];
  if Row is TcxGridDBCardViewRow then
    Result := GetFieldImeName(TcxGridDBCardViewRow(Row).DataBinding.FieldName);
end;

function TctCxGridIme.GetFieldImeName(
  ACustomView: TcxCustomGridTableView; AFieldIndex: Integer): String;
begin
  Result := Screen.DefaultIme;
  if ACustomView is TcxGridTableView then
    Result := GetFieldImeName(TcxGridTableView(ACustomView), AFieldIndex)
  else if ACustomView is TcxGridBandedTableView then
    Result := GetFieldImeName(TcxGridBandedTableView(ACustomView), AFieldIndex)
  else if ACustomView is TcxGridCardView then
    Result := GetFieldImeName(TcxGridCardView(ACustomView), AFieldIndex);
end;

function TctCxGridIme.GetFieldImeName(
  AGridView: TcxGridBandedTableView; AFieldIndex: Integer): String;
var
  Column: TcxGridColumn;
begin
  Result := Screen.DefaultIme;
  Column := AGridView.Columns[AFieldIndex];
  if Column is TcxGridDBBandedColumn then
    Result := GetFieldImeName(TcxGridDBBandedColumn(Column).DataBinding.FieldName);
end;

procedure TctCxGridIme.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) then
  begin
    if (AComponent = FGrid) then FGrid := nil;
    if (AComponent = FGridTableView) then FGridTableView := nil;
  end;
end;

procedure TctCxGridIme.SetGrid(const Value: TcxGrid);
begin
  LastImeName := none_ImeName;
  //NW@Gridƥ٭
  if not (csDesigning in ComponentState) then
  begin
    if FGrid <> nil then
    begin
      FGrid.OnEnter := FOldGridOnEnter;
      FGrid.OnExit := FOldGridOnExit;
    end;
  end;
  //Grid
  FGrid := Value;
  //ܧGridƥ
  if not (csDesigning in ComponentState) then
  begin
    FOldGridOnEnter := FGrid.OnEnter;
    FOldGridOnExit := FGrid.OnExit;
    FGrid.OnEnter := GridOnEnter;
    FGrid.OnExit := GridOnExit;
  end;
end;

procedure TctCxGridIme.SetGridTableView(
  const Value: TcxCustomGridTableView);
begin
  LastImeName := none_ImeName;
  //NW@GridViewƥ٭
  if not (csDesigning in ComponentState) then
  begin
    if FGridTableView <> nil then
      FGridTableView.OnFocusedItemChanged := FOldViewOnFocusedItemChanged;
  end;
  //GridView
  FGridTableView := Value;
  //ܧGridViewƥ
  if not (csDesigning in ComponentState) then
  begin
    FOldViewOnFocusedItemChanged := FGridTableView.OnFocusedItemChanged;
    FGridTableView.OnFocusedItemChanged := ViewOnFocusedItemChanged;
  end;
end;

procedure TctCxGridIme.ViewOnFocusedItemChanged(
  Sender: TcxCustomGridTableView; APrevFocusedItem,
  AFocusedItem: TcxCustomGridTableItem);
var
  Column: TcxGridColumn;
begin
  //Ӫƥ
  if Assigned(FOldViewOnFocusedItemChanged) then
    FOldViewOnFocusedItemChanged(Sender, APrevFocusedItem, AFocusedItem);
  //Jk
  if not Enabled then Exit;
  LastImeName := GetFieldImeName(Sender, AFocusedItem.Index);
  ActiveIme(LastImeName);
end;

end.
