{------[ TctCustomIme ]---------------------------------------------------
* ت

- Jk

* ݩ

- property ImeName: TImeName

- property Enabled: Boolean

- property Version: String

* k

- procedure ActiveIme(AImeName: String);
  NJk AImeNameC
  pGAImeNameOťթΪ̨SwAhtιw]Jk

------[ TctCustomGridIme ]---------------------------------------------------
* ت

-  Grid iH̾줧]wAJkCثe`@~ӥXTؤG
  a. TctDxGridIme   in ctDxGridIme.pas
  b. TctCxGridIme   in ctCxGridIme.pas
  c. TctCxVGridIme  in ctCxVGridIme.pas

* ݩ

- property EffectFieldNames: String
  ݭnJkW١CH ;  , }C

* @

- i@.Taipei

- vincent@family-chang.idv.tw

- ̫קG2004-05-31 PM 04:00
-------------------------------------------------------------------------------}
unit ctCustomIme;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms;

type
  TctCustomIme = class(TComponent)
  private
    FEnabled: Boolean;
    FImeName: TImeName;
    function GetVersion: String;
    procedure SetEnabled(const Value: Boolean);
    procedure SetImeName(const Value: TImeName);
    procedure SetVersion(const Value: String);
  public
    constructor Create(AOwner: TComponent); override;
    procedure ActiveIme(AImeName: String);
  published
    property ImeName: TImeName read FImeName write SetImeName;
    property Enabled: Boolean read FEnabled write SetEnabled default True;
    property Version: String read GetVersion write SetVersion;
  end;

  TctCustomGridIme = class(TctCustomIme)
  private
    FLastImeName: String;
    FEffectFieldNames: String;
    procedure SetLastImeName(const Value: String);
    procedure SetEffectFieldNames(const Value: String);
  protected
    FOldGridOnEnter: TNotifyEvent;
    FOldGridOnExit: TNotifyEvent;
    procedure GridOnEnter(Sender: TObject); virtual;
    procedure GridOnExit(Sender: TObject); virtual;
    procedure ActiveLastIme; virtual;
  protected
    FEffectFieldList: TStringList;
    property LastImeName: String read FLastImeName write SetLastImeName;
    procedure PrepareEffectFieldList;
    function  GetFieldImeName(AFieldName: String): String; virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property EffectFieldNames: String read FEffectFieldNames write SetEffectFieldNames;
  end;

const
  none_ImeName = '(none)';

implementation

{ TctCustomIme }

constructor TctCustomIme.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FImeName := Screen.DefaultIme;
  FEnabled := True;
end;

procedure TctCustomIme.ActiveIme(AImeName: String);
var
  HandleToSet: HKL;
begin
  if (AImeName = none_ImeName) or (AImeName = '') or
     (AImeName = Screen.DefaultIme) then
  begin
    HandleToSet := Screen.DefaultKbLayout;
    ActivateKeyboardLayout(HandleToSet, KLF_ACTIVATE);
  end
  else
    Controls.SetImeName(AImeName);
end;

function TctCustomIme.GetVersion: String;
begin
  Result := '2004-05-31 AM 10:00';
end;

procedure TctCustomIme.SetEnabled(const Value: Boolean);
begin
  FEnabled := Value;
end;

procedure TctCustomIme.SetImeName(const Value: TImeName);
begin
  FImeName := Value;
end;

procedure TctCustomIme.SetVersion(const Value: String);
begin
  //nothing ...
end;

{ TctCustomGridIme }

procedure TctCustomGridIme.ActiveLastIme;
begin
  ActiveIme(FLastImeName);
end;

constructor TctCustomGridIme.Create(AOwner: TComponent);
begin
  inherited;
  FEffectFieldList := TStringList.Create;
  FLastImeName := none_ImeName;
end;

destructor TctCustomGridIme.Destroy;
begin
  FEffectFieldList.Free;
  inherited;
end;

function TctCustomGridIme.GetFieldImeName(AFieldName: String): String;
begin
  Result := Screen.DefaultIme;
  if (ImeName <> Screen.DefaultIme) then
  begin
    PrepareEffectFieldList;
    if FEffectFieldList.Count = 0 then Exit;

    AFieldName := Uppercase(AFieldName);
    if FEffectFieldList.IndexOf(AFieldName) >= 0 then
      Result := ImeName
  end;
end;

procedure TctCustomGridIme.GridOnEnter(Sender: TObject);
begin
  //쥻ƥ
  if Assigned(FOldGridOnEnter) then
    FOldGridOnEnter(Sender);
  //iJGridAHu̫᪺JkvJk
  if not Enabled then Exit;
  ActiveLastIme;
end;

procedure TctCustomGridIme.GridOnExit(Sender: TObject);
var
  HandleToSet: HKL;
begin
  //Ӫƥ
  if Assigned(FOldGridOnExit) then
    FOldGridOnExit(Sender);
  //b}GridɡAJk٭쬰tιw]ȡC
  //pGS@oӰʧ@AӤUӨoJI󪺿JkOŪɡA
  //|T٭uSJkvA
  if not Enabled then Exit;
  HandleToSet := Screen.DefaultKbLayout;
  ActivateKeyboardLayout(HandleToSet, KLF_ACTIVATE);
end;

procedure TctCustomGridIme.PrepareEffectFieldList;
var
  i: Integer;
  S, Tmp: String;
begin
  if (FEffectFieldNames = '') or (FEffectFieldList.Count > 0) then Exit;

  S := StringReplace(FEffectFieldNames, ',', ';', [rfReplaceAll]);
  Repeat
    i := Pos(';', S);
    if i > 0 then
    begin
      Tmp := Trim(Copy(S, 1, i-1));
      S := Copy(S, i+1, MaxInt);
    end
    else
      Tmp := Trim(S);
    FEffectFieldList.Add(Uppercase(Tmp));
  Until (i <= 0);
end;

procedure TctCustomGridIme.SetEffectFieldNames(const Value: String);
begin
  FEffectFieldNames := Value;
  FEffectFieldList.Clear;
  LastImeName := none_ImeName;
end;

procedure TctCustomGridIme.SetLastImeName(const Value: String);
begin
  FLastImeName := Value;
end;

end.
